<?php

/**
 * inf_pago_cheque actions.
 *
 * @package    nomina
 * @subpackage inf_pago_cheque
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class inf_pago_chequeActions extends sfActions {

    /**
     * Executes list action
     *
     * @param sfRequest $request A request object
     */
    public function executeList(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Paginacion
         */
        if (isset($request['_startRow'])) {
            $rowStart = $request['_startRow'];
        } else {
            $rowStart = 0;
        }

        if (isset($request['_endRow'])) {
            $rowEnd = $request['_endRow'];
        } else {
            $rowEnd = 75;
        }

        //ordenar consulta
        if (isset($request['_sortBy'])) {
            $sortBy = " Order by " . $request['_sortBy'];
        } else {
            $sortBy = 'order by ID_PERIODO , ID_TIPO_DOC , NUM_DOC';
        }


        /*
         * Manejo de errores
         */
        try {
            /*
             * Variables obligatorias
             */
            $periodo_filtro = $request['id_periodo_filtro'];
            $periodo = $request['id_periodo'];

            /*
             * Variables opcionales
             */
            //funcionario
            if (isset($request['num_doc'])) {
                $whereFuncionarioNumDoc = " AND tab0.num_doc = " . $request['num_doc'];
            } else {
                $whereFuncionarioNumDoc = ' ';
            }
            //funcionario
            if (isset($request['id_tipo_doc'])) {
                $whereFuncionarioTipoDoc = " AND tab0.id_tipo_doc = " . $request['id_tipo_doc'];
            } else {
                $whereFuncionarioTipoDoc = ' ';
            }

            //sentencia sql
            $sql = <<<EOD
ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD"
EOD;
            //ejecuta y obtiene el resultado del sql
            CN_TABLE::executeSQL($sql);

            /*
             * sql que trae los resultados
             * por los filtros, para totalizar las filas
             */
            $sql = <<<EOD
select count(*) as count from (

select 
tab0.*,
(select distinct periodo.periodo from no_periodo_v periodo where periodo.id_periodo = $periodo_filtro) AS PERIODO

 from (

select
liqnom.id_tipo_doc,
liqnom.num_doc,
liqnom.nombre_apellido,
liqnom.nombre_completo,
sum(
case when liqnom.operador = 1 then liqnom.valor_liquidado else liqnom.valor_liquidado * (-1) end
) as valor_liquidado,
liqnom.id_periodo,
pagfun.id_pago_func

from no_liquida_nomina_v liqnom

left join no_pago_func pagfun
on pagfun.id_tipo_doc = liqnom.id_tipo_doc
and pagfun.num_doc = liqnom.num_doc
and pagfun.estado = 1

group by
liqnom.id_tipo_doc,
liqnom.num_doc,
liqnom.nombre_apellido,
liqnom.nombre_completo,
liqnom.id_periodo,
pagfun.id_pago_func

)tab0

where tab0.id_pago_func is null
and tab0.id_periodo = $periodo_filtro
$whereFuncionarioNumDoc
$whereFuncionarioTipoDoc
    
)
EOD;


            $total_record_count = CN_TABLE::executeSQL($sql);
            $total_record_count = $total_record_count[0]["count"];


            //obtener el listado de recaudos
            $sql = <<<EOD
SELECT * FROM ( SELECT row_.*, ROWNUM rownum_ FROM (

select 
tab0.*,
(select distinct periodo.periodo from no_periodo_v periodo where periodo.id_periodo = $periodo_filtro) AS PERIODO

 from (

select
liqnom.id_tipo_doc,
liqnom.num_doc,
liqnom.nombre_apellido,
liqnom.nombre_completo,
sum(
case when liqnom.operador = 1 then liqnom.valor_liquidado else liqnom.valor_liquidado * (-1) end
) as valor_liquidado,
liqnom.id_periodo,
pagfun.id_pago_func

from no_liquida_nomina_v liqnom

left join no_pago_func pagfun
on pagfun.id_tipo_doc = liqnom.id_tipo_doc
and pagfun.num_doc = liqnom.num_doc
and pagfun.estado = 1

group by
liqnom.id_tipo_doc,
liqnom.num_doc,
liqnom.nombre_apellido,
liqnom.nombre_completo,
liqnom.id_periodo,
pagfun.id_pago_func

)tab0

where tab0.id_pago_func is null
and tab0.id_periodo = $periodo_filtro
$whereFuncionarioNumDoc
$whereFuncionarioTipoDoc
    
$sortBy
          
) row_ WHERE ROWNUM <=  $rowEnd   ) where rownum_ >  $rowStart
EOD;
            //ejecuta y obtiene el resultado del sql
            $resultado = CN_TABLE::executeSQL($sql);


            $this->totalRows = $total_record_count;
            $this->startRow = $rowStart;
            $this->endRow = $rowStart + count($resultado);
            $this->list_data = $resultado;
            $this->logMessage("[inf_pago_cheque] Consulta exitosa.");
        } catch (Exception $e) {

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

    /**
     * Metodo para sumar 
     *
     * @param sfWebRequest $request
     */
    public function executeSum(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------/  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Paginacion
         */
        if (isset($request['_startRow'])) {
            $rowStart = $request['_startRow'];
        } else {
            $rowStart = 0;
        }

        if (isset($request['_endRow'])) {
            $rowEnd = $request['_endRow'];
        } else {
            $rowEnd = 75;
        }

        //ordenar consulta
        if (isset($request['_sortBy'])) {
            $sortBy = " Order by " . $request['_sortBy'];
        } else {
            $sortBy = 'order by id_tipo_doc, num_doc ';
        }

        //manejo de errores
        try {
            /*
             * Variables obligatorias
             */
            $periodo_filtro = $request['id_periodo_filtro'];
            $periodo = $request['id_periodo'];

            /*
             * Variables opcionales
             */
            //funcionario
            if (isset($request['num_doc'])) {
                $whereFuncionarioNumDoc = " AND tab0.num_doc = " . $request['num_doc'];
            } else {
                $whereFuncionarioNumDoc = ' ';
            }
            //funcionario
            if (isset($request['id_tipo_doc'])) {
                $whereFuncionarioTipoDoc = " AND tab0.id_tipo_doc = " . $request['id_tipo_doc'];
            } else {
                $whereFuncionarioTipoDoc = ' ';
            }

            //obtener el listado de recaudos
            $sql = <<<EOD
SELECT

'Totales: ' || count(*) as periodo,
SUM(valor_liquidado)  as valor_liquidado

FROM (  

select 
tab0.*,
(select distinct periodo.periodo from no_periodo_v periodo where periodo.id_periodo = $periodo_filtro) AS PERIODO

 from (

select
liqnom.id_tipo_doc,
liqnom.num_doc,
liqnom.nombre_apellido,
liqnom.nombre_completo,
sum(
case when liqnom.operador = 1 then liqnom.valor_liquidado else liqnom.valor_liquidado * (-1) end
) as valor_liquidado,
liqnom.id_periodo,
pagfun.id_pago_func

from no_liquida_nomina_v liqnom

left join no_pago_func pagfun
on pagfun.id_tipo_doc = liqnom.id_tipo_doc
and pagfun.num_doc = liqnom.num_doc
and pagfun.estado = 1

group by
liqnom.id_tipo_doc,
liqnom.num_doc,
liqnom.nombre_apellido,
liqnom.nombre_completo,
liqnom.id_periodo,
pagfun.id_pago_func

)tab0

where tab0.id_pago_func is null
and tab0.id_periodo = $periodo_filtro
$whereFuncionarioNumDoc
$whereFuncionarioTipoDoc
    
$sortBy

)
EOD;
            //ejecuta y obtiene el resultado del sql
            $resultado = CN_TABLE::executeSQL($sql);

            $this->totalRows = count($resultado);
            $this->startRow = 0;
            $this->endRow = count($resultado);
            $this->list_data = $resultado;
        } catch (Exception $e) {

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

}
